#include <IRremote.h>
#include <IRremoteInt.h>


/*************************************
 *     *     TIME:20202.04.25
 *     Development Team: MYLS Technology Co.
 *     INFRARED REMOTE CONTROL
 *     מצב שליטה בשלט  אינפרא אדום        
 *     זכור!  יש להתקין קודם את הספריות של אירפרא אדום
 * 
 **************************************/

//------- IR REMOTE CODES ---------//
#define FORWARD 0xFF18E7   //16718055  
#define BACK    0xFF4AB5    //16730805
#define LEFT    0xFF10EF    //16716015
#define RIGHT   0xFF5AA5    //16734885
#define  STOP   0xFF38C7    //16726215
#define Buzzer  0xFF6897   //16738455  (*)
#define Light   0xFFB04F     //16738455  (#)
#define RECV_PIN  2

int AD6= 6;     
int AD7 = 7;       
int BD9 = 9;      
int BD8 = 8;

#define carSpeed 200  // initial speed of car >=0 to <=255


IRrecv irrecv(RECV_PIN);
decode_results results;
unsigned long val;
unsigned long preMillis;

void forward() {

 digitalWrite(AD6, HIGH);
  digitalWrite(AD7, LOW);
  digitalWrite(BD8, HIGH);
  digitalWrite(BD9, LOW);


}

void back(){
  digitalWrite(AD6, LOW);
  digitalWrite(AD7, HIGH);
  digitalWrite(BD8, LOW);
  digitalWrite(BD9, HIGH);

  Serial.println("go back!");
}

void left(){
  
  digitalWrite(AD6, HIGH);
  digitalWrite(AD7, LOW);
  digitalWrite(BD8, LOW);
  digitalWrite(BD9, LOW);
  
}

void right(){
  digitalWrite(AD6, LOW);
  digitalWrite(AD7, LOW);
  digitalWrite(BD8, HIGH);
  digitalWrite(BD9, LOW);
   
}

void stop_it()
{
  digitalWrite(AD6, LOW);
  digitalWrite(AD7, LOW);
  digitalWrite(BD8, LOW);
  digitalWrite(BD9, LOW);
}


void setup() {
  Serial.begin(9600);
  pinMode(AD6, OUTPUT);
  pinMode(AD7, OUTPUT); 
  pinMode(BD9, OUTPUT);
  pinMode(BD8, OUTPUT);  
  stop_it();
  irrecv.enableIRIn();
}
////////////////////////////////
  
void loop() {
  if (irrecv.decode(&results)){ 
    preMillis = millis();
    val = results.value;
    Serial.println(val, HEX); 
    irrecv.resume();
   switch(val){
      case FORWARD: forward();  break;
      case BACK:    back();     break;
      case LEFT:    left();     break;
      case RIGHT:   right();    break;
      case STOP:    stop_it();     break;   
      
      default:                  break;
    }
  }
  else{
    if(millis() - preMillis > 500){
      stop_it();
      preMillis = millis();
    }
  }
}
